VERSION 5.00
Begin VB.Form Logger 
   Caption         =   "Count-Logger"
   ClientHeight    =   1860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3810
   Icon            =   "Logger.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   124
   ScaleMode       =   0  'Benutzerdefiniert
   ScaleWidth      =   220.501
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   2160
      TabIndex        =   11
      Text            =   "3600"
      Top             =   480
      Width           =   1575
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1920
      TabIndex        =   4
      Text            =   "Neue_Messreihe"
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton Command7 
      Caption         =   "Schlieen"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1320
      Width           =   975
   End
   Begin VB.CommandButton Command3 
      Caption         =   "ffnen"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   975
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Logger.frx":469A
      Left            =   240
      List            =   "Logger.frx":469C
      TabIndex        =   0
      Text            =   "COM1"
      Top             =   480
      Width           =   975
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   2880
      Tag             =   "Aktualisierung"
      Top             =   960
   End
   Begin VB.Frame Frame3 
      Caption         =   "Verbindung"
      Height          =   1695
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "00:00:00"
      Height          =   255
      Left            =   1920
      TabIndex        =   10
      Top             =   840
      Width           =   735
   End
   Begin VB.Label Label5 
      Caption         =   "Zeit:"
      Height          =   255
      Left            =   1440
      TabIndex        =   9
      Top             =   840
      Width           =   495
   End
   Begin VB.Label Label6 
      Caption         =   "0"
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label Label7 
      Caption         =   "Counts"
      Height          =   255
      Left            =   1440
      TabIndex        =   7
      Top             =   1200
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Intervall:"
      Height          =   255
      Left            =   1440
      TabIndex        =   6
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label4 
      Caption         =   "Titel:"
      Height          =   255
      Left            =   1440
      TabIndex        =   5
      Top             =   120
      Width           =   615
   End
End
Attribute VB_Name = "Logger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  'Count-Logger
  '2013 erstellt von Benedikt Zimmermann (benezi95@yahoo.de)
  'auf Grundlage des Programms Alpha_Gamma von Burkhard Kainka.
  'Bei Rckfragen an Herrn Kainka oder Herrn Zimmermann
  '------------------------------------------------------------------------------------------------
  'Beschreibung:
  'Das Programm zeichnet die Counts in einem gewissen Intervall ber einen lngere Zeitraum auf.
  'Es arbeitet mit einem externen Zeitgeber,
  'da der Timer von VisualBasic einerseits ungenau ist,
  'anderseits begrenzt in seiner Zeitspanne ist.
  'Dieses Programm greift auf einen Zeitwert in Millisekunden zurck,
  'den Windows seit Beginn des letzten Systemstarts hochzhlt.
  'Bei Beginn einer neuen Messung wird die Startzeit in der Variabel
  'ClockCount und IntervallCount gespeichert. ClockCount ist der Zeitpunkt des Beginns
  'der Messung und wird nicht mehr verndert. Er dient zur Berechnung der Zeitanzeige.
  'IntervallCount nun dient nun als Intervallzeitgeber.
  'Einmal in der Sekunde lst ein einfacher Timer eine Prozedur aus,
  'die sowohl die Anzeige der UserForm aktualisiert, als auch vergleicht, ob die Differenz
  'zwischen IntervallCount und aktuller Zeit bereits das angegebene Intervall berschritten hat.
  'Ist dies der Fall, wird der Wert in einer Datei gespeichert. IntervallCount wird neu gesetzt
  'und Counts zurckgesetzt.
  '------------------------------------------------------------------------------------------------
  'VORSICHT: Da der Titel direkt zur Erstellung der Log-Datei herangezogen wird, sollte er keine Sonderzeichen enthalten,
  'ansonsten wird keine Log-Datei erstellt.
  
  'Deklaration der Variabeln und Funktionen. Nur Globale Variabeln werden deklariert.
  Public s, h, m As Integer
  Public Counts As Double
  Public ClockCount, IntervallCount As Long
  Private Declare Function GetTickCount Lib "kernel32" () As Long 'Funktion um die Systemzeit auszulesen
    
 Private Sub Form_Load()
  Combo1.AddItem "COM1"
  Combo1.AddItem "COM2"
  Combo1.AddItem "COM3"
  Combo1.AddItem "COM4"
  Combo1.AddItem "COM5"
  Combo1.AddItem "COM6"
  Combo1.ListIndex = 1
  Timer1.Enabled = False
End Sub

Private Sub Neue_Messung()
  h = 0 'Zurcksetzen der Zeitwerte fr die Anzeige
  m = 0
  s = 0
  Counts = 0
  ClockCount = GetTickCount() 'ClockCount speichert den Zeitpunkt seit Beginn der Messung
  IntervallCount = GetTickCount() 'IntervallCount speichert den Zeitpunkt seit dem das Intervall gezhlt wird.
End Sub
Private Sub Command3_Click() 'Start einer neuen Messung
   CLOSECOM
   If Combo1.ListIndex = 0 Then I = OPENCOM("COM1:19200,N,8,1")
   If Combo1.ListIndex = 1 Then I = OPENCOM("COM2:19200,N,8,1")
   If Combo1.ListIndex = 2 Then I = OPENCOM("COM3:19200,N,8,1")
   If Combo1.ListIndex = 3 Then I = OPENCOM("COM4:19200,N,8,1")
   If Combo1.ListIndex = 4 Then I = OPENCOM("COM5:19200,N,8,1")
   If Combo1.ListIndex = 5 Then I = OPENCOM("COM6:19200,N,8,1")
  If I = 0 Then
    MsgBox ("Es konnte keine Verbindung hergestellt werden!")
    Timer1.Enabled = False
  Else 'Falls Verbindung erfolgreich
    Neue_Messung 'Messung starten
    Timer1.Interval = 1000 'Intervall des Timers, der die Intervallwerte vergleicht
    Timer1.Enabled = True
  End If
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
Messung_Beenden
End Sub

Private Sub Timer1_Timer()
'Einmal in der Sekunde wird ausgelesen, wie viel
'Sekndlich wird ausgelesen, wie viele Counts gemessen wurden.
'Die Variabel Counts wird jeweils um 1 erhht.
While INBUFFER() > 0
    d = READBYTE()
    Counts = Counts + 1
Wend
  

Uhrzeit_holen 'Zeitgeber auslesen

'Durch zwei If-Bedingungen wird die Anzeige der Zeit seit Start der
'Messungen mit anfhrenden Nullen angezeigt.
Uhr = h
If m < 10 Then
Uhr = Uhr & ":0" & m
Else
Uhr = Uhr & ":" & m
End If

If s < 10 Then
Uhr = Uhr & ":0" & s
Else
Uhr = Uhr & ":" & s
End If

'Zeit und Counts seit letztem Intervall werden angzeigt.
Label3.Caption = Uhr
Label6.Caption = Counts


If (GetTickCount() - IntervallCount) / 1000 >= Val(Text2.Text) Then 'bedeutete: Wenn Zeit_Jetzt-Zeit_Letztes_Intervallende (/1000 weil Millisekunden) grer als Intervall, dann
Speichern 'starte Speicher Prozedur
IntervallCount = GetTickCount() 'IntervallCount auf Jetzt-Zeit zurcksetzen
Counts = 0
End If
End Sub


Private Sub Speichern()
On Error Resume Next 'Nicht abbrechen bei Fehlern
Pfad = App.Path & "\DATA\" 'Log-Files werden in einem Unterverzeichnis mit dem Titel DATA gespeichert
If Dir(Pfad, vbDirectory) = "" Then 'prfe, ob dies vorhanden ist
MkDir Pfad 'wenn nein, dann erstelle dies.
End If

Pfad = App.Path & "\DATA\" & Text1.Text & "_Intervall_" & Text2.Text & ".csv" 'konstruiert den spteren Namen der Datei. Enthlt Titel und Intervall

If Dir(Pfad) = "" Then 'Prft ob Datei vorhanden ist, wenn nein, dann wird diese neu angelegt
    DateiNr = FreeFile
    Open Pfad For Output As DateiNr
    Print #DateiNr, Date$ & ";" & Time$ & ";" & Counts 'und Datensatz in der Form Datum;Uhrzeit;Counts gespeichert
    Close DateiNr
Else 'wenn Datei vorhanden,
    DateiNr = FreeFile
    Open Pfad For Append As DateiNr 'dann hnge Datensatz an
    Print #DateiNr, Date$ & ";" & Time$ & ";" & Counts
Close DateiNr
End If
End Sub

Private Sub Uhrzeit_holen()
'Prozedur errechnet die Dauer der Messung
Clock_Differenz = GetTickCount() - ClockCount
'Umrechnung der Zahlenwerte in Millisekunden in Werte Stunde, Minute, Sekunde
h = Clock_Differenz \ 3600000
m = (Clock_Differenz Mod 3600000) \ 60000
s = ((Clock_Differenz Mod 3600000) Mod 60000) \ 1000
End Sub

Private Sub Command7_Click() 'Schlieen-Button
Messung_Beenden
End Sub

Private Sub Messung_Beenden()
'Timer wird beendet, COM-Verbindung geschlossen
Timer1.Enabled = False
CLOSECOM
End Sub
